﻿using System;
using Android.Hardware;
using CameraDifference.Droid;
using Xamarin.Forms;
using Xamarin.Forms.Platform.Android;

[assembly: ExportRenderer (typeof(CameraDifference.CameraPreview), typeof(CameraPreviewRenderer))]
namespace CameraDifference.Droid
{
	public class CameraPreviewRenderer : ViewRenderer<CameraDifference.CameraPreview, CameraDifference.Droid.CameraPreview>
	{
		CameraPreview _cameraPreview;
		Speech_Droid _speech = new Speech_Droid();

		protected override void OnElementChanged (ElementChangedEventArgs<CameraDifference.CameraPreview> e)
		{
			base.OnElementChanged (e);

			if (Control == null) {
				_cameraPreview = new CameraPreview (Context);
				SetNativeControl (_cameraPreview);
			}

			if (e.OldElement != null)
			{
				_cameraPreview.Click -= OnCameraPreviewClicked;
			}
			if (e.NewElement != null)
			{
				Control.Preview = Camera.Open((int)e.NewElement.Camera);
				_cameraPreview.Click += OnCameraPreviewClicked;
			}
		}

		void OnCameraPreviewClicked(object sender, EventArgs e)
		{
			if (Element.Camera == CameraOptions.Spot)
				_speech.Speak("Wrong");
		}

		protected override void OnElementPropertyChanged(object sender, System.ComponentModel.PropertyChangedEventArgs e)
		{
			base.OnElementPropertyChanged(sender, e);

			if ( Element.Camera == CameraOptions.Spot )
				_cameraPreview.Preview.StopPreview();
		}

		protected override void Dispose (bool disposing)
		{
			if (disposing) {
				Control.Preview.Release ();
			}
			base.Dispose (disposing);
		}
	}
}
