﻿using System;
using CameraDifference;
using CameraDifference.iOS;
using Xamarin.Forms;
using Xamarin.Forms.Platform.iOS;

[assembly: ExportRenderer (typeof(CameraPreview), typeof(CameraPreviewRenderer))]
namespace CameraDifference.iOS
{
	public class CameraPreviewRenderer : ViewRenderer<CameraPreview, UICameraPreview>
	{
		UICameraPreview _uiCameraPreview;

		protected override void OnElementChanged (ElementChangedEventArgs<CameraPreview> e)
		{
			base.OnElementChanged (e);

			if (Control == null) {
				_uiCameraPreview = new UICameraPreview (e.NewElement.Camera);
				SetNativeControl (_uiCameraPreview);
			}
			if (e.OldElement != null)
			{
			}
			if (e.NewElement != null)
			{
			}
		}

		protected override void OnElementPropertyChanged(object sender, System.ComponentModel.PropertyChangedEventArgs e)
		{
			base.OnElementPropertyChanged(sender, e);

			if (_uiCameraPreview._cameraOptions == CameraOptions.TakePhoto
			&& Element.Camera == CameraOptions.Spot)
			{
				var sound = new AudioToolbox.SystemSound(1108);
				sound.PlaySystemSound();
				_uiCameraPreview._captureSession.StopRunning();
			}
			Control._cameraOptions = Element.Camera;
		}


		protected override void Dispose (bool disposing)
		{
			if (disposing) {
				Control._captureSession.Dispose ();
				Control.Dispose ();
			}
			base.Dispose (disposing);
		}
	}
}
