﻿using Xamarin.Forms;
using CameraDifference.iOS;
using AVFoundation;

[assembly: Dependency(typeof(Speech_iOS))]

namespace CameraDifference.iOS
{
	public class Speech_iOS : ITextToSpeech
	{
		static AVSpeechSynthesizer _speechSynthesizer = new AVSpeechSynthesizer();
		float _volume = 1.0f;
		float _pitch = 1.0f;
		public void Speak(string text)
		{
			if (!string.IsNullOrWhiteSpace(text))
			{
				_speechSynthesizer.StopSpeaking(AVSpeechBoundary.Immediate);
				var speechUtterance = new AVSpeechUtterance(text)
				{
					Rate = AVSpeechUtterance.MaximumSpeechRate / 4,
					Voice = AVSpeechSynthesisVoice.FromLanguage("en-US"),
					Volume = _volume,
					PitchMultiplier = _pitch
				};
				_speechSynthesizer.SpeakUtterance(speechUtterance);
			}
		}
	}
}
