using System;
using Xamarin.Forms;

namespace CameraDifference
{
	public partial class CameraPage : ContentPage
	{
		Random rnd = new Random();

		public CameraPage()
		{
			InitializeComponent();

			_takePhotoButton.Clicked += (sender, e) =>
			{
				_takePhotoButton.IsVisible = false;
				_cameraControl.Camera = CameraOptions.Spot;
				_answerButton.TranslationX = Width * (rnd.NextDouble()*0.9);
				_answerButton.TranslationY = Height * (rnd.NextDouble()*0.9);
				_answerButton.IsVisible = true;
			};

			_answerButton.Clicked += (sender, e) =>
			{
				_rightButton.IsVisible = true;
				_cameraControl.Camera = CameraOptions.Answer;
				var speech = DependencyService.Get<ITextToSpeech>();
				speech.Speak("Right");
			};

			_rightButton.Clicked += async (sender, e) =>
			{
				await Navigation.PopAsync();
			};
		}
	}
}
